Arch CloseHoles: Difference between revisions

From FreeCAD Documentation
mNo edit summary
No edit summary
Line 32: Line 32:


==Scripting== <!--T:6-->
==Scripting== <!--T:6-->

{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Arch_API|Arch API]] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].


<!--T:7-->
<!--T:7-->
This tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
This tool can be used in [[Macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=

Revision as of 08:32, 16 May 2023

Arch CloseHoles

Menu location
Arch → Utilities → Close holes
Workbenches
Arch
Default shortcut
None
Introduced in version
-
See also
Arch Check

Description

This tool identifies holes (circular sequence of open edges) in a Shape object and attempts to close it by adding it a new face made from that edges sequence. You must still verify yourself that the result is a solid, though.

Usage

  1. Select a Shape object.
  2. Press the Close Holes entry in Arch → Utilities → Close Holes.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

This tool can be used in macros and from the Python console by using the following function:

solid = closeHole(shape)
  • Closes a hole in a shape, which is a Part.Shape, and returns the new solid object.

Example:

import FreeCAD, Draft, Arch

Line = Draft.makeWire([FreeCAD.Vector(0, 0, 0),FreeCAD.Vector(2000, 2000, 0)])
Wall = Arch.makeWall(Line, width=150, height=3000)

Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 900
Box.Width = 450
Box.Height = 2000
FreeCAD.ActiveDocument.recompute()

Draft.rotate(Box, 45)
Draft.move(Box, FreeCAD.Vector(1000, 700, 0))

Arch.removeComponents(Box, Wall)
FreeCAD.ActiveDocument.recompute() 

solid = Arch.closeHole(Wall.Shape)